/* cmdline.h */

/* File autogenerated by gengetopt version 2.18  */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "dlacluster"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "0.01"
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  char * conf_in_arg;	/* A configuration file (default='duffing_i.conf').  */
  char * conf_in_orig;	/* A configuration file original value given at command line.  */
  const char *conf_in_help; /* A configuration file help description.  */
  char * conf_out_arg;	/* A save configuration file (default='duffing_o.conf').  */
  char * conf_out_orig;	/* A save configuration file original value given at command line.  */
  const char *conf_out_help; /* A save configuration file help description.  */
  char * dir_in_arg;	/* input dir (default='./').  */
  char * dir_in_orig;	/* input dir original value given at command line.  */
  const char *dir_in_help; /* input dir help description.  */
  char * dir_out_arg;	/* output dir (default='./').  */
  char * dir_out_orig;	/* output dir original value given at command line.  */
  const char *dir_out_help; /* output dir help description.  */
  int nx_arg;	/* cluster x size (default='1000').  */
  char * nx_orig;	/* cluster x size original value given at command line.  */
  const char *nx_help; /* cluster x size help description.  */
  int ny_arg;	/* cluster y size (default='1000').  */
  char * ny_orig;	/* cluster y size original value given at command line.  */
  const char *ny_help; /* cluster y size help description.  */
  int step_arg;	/* cluster growth steps (default='100').  */
  char * step_orig;	/* cluster growth steps original value given at command line.  */
  const char *step_help; /* cluster growth steps help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int conf_in_given ;	/* Whether conf-in was given.  */
  int conf_out_given ;	/* Whether conf-out was given.  */
  int dir_in_given ;	/* Whether dir-in was given.  */
  int dir_out_given ;	/* Whether dir-out was given.  */
  int nx_given ;	/* Whether nx was given.  */
  int ny_given ;	/* Whether ny was given.  */
  int step_given ;	/* Whether step was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
