#include <stdio.h>
#include "chk.h"
#include "debug_print.h"
#include "dma_dbl_array.h"
/*
 * dynamic memory allocation double array
 */
dma_dbl_array *dma_array_new(array_num)
size_t array_num;
{
	dma_dbl_array *dma_array;
	dma_array = (dma_dbl_array *) chk_calloc(1, sizeof(double));
	printf("# dma_array_new\n");
	DEBUG_PRINT1(dma_array);
	dma_array->size = array_num;
	DEBUG_PRINT2("% d", dma_array->size);
	dma_array->data = (double *) chk_calloc(array_num, sizeof(double));
	DEBUG_PRINT1(dma_array->data);
	DEBUG_PRINT2("% e", dma_array->data[0]);
	DEBUG_PRINT2("% e", dma_array->data[1]);
	printf("# dma_array_new\n");
	return dma_array;
}

void dma_array_free(dma_array)
dma_dbl_array *dma_array;
{
	printf("# dma_array_free\n");
	DEBUG_PRINT2("% d", dma_array->size);
	DEBUG_PRINT1(dma_array->data);
	free(dma_array->data);
	dma_array->data = NULL;
	DEBUG_PRINT1(dma_array);
	free(dma_array);
	dma_array = NULL;
	printf("# dma_array_free\n");
	return;
}

double dma_array_get(dma_array, index)
dma_dbl_array *dma_array;
size_t index;
{
	if (index < dma_array->size) {
		return dma_array->data[index];
	} else {
		fprintf(stderr,
			"# ERROR: greater index than allocated size is specified.\n");
		exit(EXIT_FAILURE);
	}
}

int dma_array_set(dma_array, index, value)
dma_dbl_array *dma_array;
size_t index;
double value;
{
	if (index < dma_array->size) {
	} else {
		double *data2;
		size_t size2 = 0;
		size2 = index + 1;
		/*
		   if(dma_array->size<(SIZE_MAX - 1)/2){
		   size2 = dma_array->size * 2 + 1;
		   }else{
		   size2 = index + 1;
		   }
		 */
		data2 =
		    (double *) realloc(dma_array->data,
				       size2 * sizeof(double));
		if (data2 == NULL) {
			DEBUG_PRINT1(dma_array);
			DEBUG_PRINT2("%u", dma_array->size);
			DEBUG_PRINT1(dma_array->data);
			DEBUG_PRINT2("% e", dma_array->data[0]);
			DEBUG_PRINT2("% e", dma_array->data[1]);
			DEBUG_PRINT2("% .16e",
				     dma_array->data[dma_array->size - 1]);
			DEBUG_PRINT2("% .16e",
				     dma_array->data[dma_array->size]);
			free(dma_array->data);
			fprintf(stderr, "# ERROR: % d realloc failure.\n",
				size2);
			exit(EXIT_FAILURE);
			return 1;
		} else {
			dma_array->size = size2;
			dma_array->data = data2;
			/*
			   DEBUG_PRINT1(dma_array->data);
			   DEBUG_PRINT2("% e", dma_array->data[0]);
			   printf("realloc % d",size2);
			   free(data2);
			 */
		}
	}
	dma_array->data[index] = value;
	return 0;
}

void dma_array_print(dma_array)
dma_dbl_array *dma_array;
{
	size_t i = 0;
	size_t array_num = dma_array->size;
	printf("# dma_array_print\n");
	DEBUG_PRINT1(dma_array);
	DEBUG_PRINT2("% d", dma_array->size);
	DEBUG_PRINT1(dma_array->data);
	for (i = 0; i < array_num; i++) {
		printf("%u\t", i);
		printf("% e\n", dma_array_get(dma_array, i));
		/*
		   dma_array_set(dma_array,i,(double)i);
		 */
	}
	printf("\n");
	printf("# dma_array_print\n");
	return;
}

void dma_array_test(array_num)
size_t array_num;
{
	dma_dbl_array *dma_array;
	printf("# dma_array_test\n");
	DEBUG_PRINT1(dma_array);
	dma_array = dma_array_new(array_num);
	DEBUG_PRINT1(dma_array);
	DEBUG_PRINT1(*dma_array);
	dma_array_print(dma_array);
	DEBUG_PRINT1(dma_array);
	dma_array_free(dma_array);
	DEBUG_PRINT1(dma_array);
	printf("# dma_array_test\n");
	return;
}
