#include <stdio.h>
#include <gsl/gsl_math.h>
#include "debug_print.h"
#include "radian.h"
double norm_rad(theta)
double theta;
{
	return norm_rad2(theta);
}

double norm_rad1(theta)
double theta;
{
	/*
	 * real    0m15.216s
	 * user    0m10.701s
	 * sys     0m0.072s
	 */
	const double T = 2 * M_PI;
	/*
	   while( theta < -M_PI || M_PI <= theta ){
	 */
	while (gsl_fcmp(theta, -M_PI, GSL_DBL_EPSILON) < 0
	       || gsl_fcmp(M_PI, theta, GSL_DBL_EPSILON) <= 0) {
		theta -= GSL_SIGN(theta) * T;
	}
	return theta;
}

double norm_rad2(theta)
double theta;
{
	/*
	 * real    0m0.021s
	 * user    0m0.016s
	 * sys     0m0.000s
	 */
	const double T = 2 * M_PI;
	theta = fmod(theta, T);
	while (gsl_fcmp(theta, -M_PI, GSL_DBL_EPSILON) < 0
	       || gsl_fcmp(M_PI, theta, GSL_DBL_EPSILON) <= 0) {
		theta -= GSL_SIGN(theta) * T;
	}
	return theta;
}

void norm_rad_test(a)
void *a;
{
	int i = 0;
	double theta_sta = -10000 * M_PI;
	double theta_end = -theta_sta;
	int theta_num = 1000;
	double theta_str = (theta_end - theta_sta) / (double) theta_num;
	double theta = theta_sta;
	for (i = 0; i < theta_num; i++) {
		theta += theta_str;
		printf("% .16e\t", theta);
		printf("% .16e\t", norm_rad1(theta));
		printf("% .16e\t", norm_rad2(theta));
		printf("% d\n", i);
	}
	return;
	DEBUG_PRINT1(a);
}
