#include <stdio.h>
#include <stdint.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_const_mksa.h>
#include <gsl/gsl_const_num.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_odeiv.h>
#include <gsl/gsl_sf_bessel.h>
#include <gsl/gsl_multifit_nlin.h>
#include <gsl/gsl_blas.h>
#include "chk.h"
#include "debug_print.h"
#include "dma_dbl_array.h"
#include "radian.h"

#define norm_rad(theta) (theta)
/*
#include <alloca.h>
*/
typedef struct {
	double m;
	int l;
	double E;
	double V_0;
	double omega;
	double r_max;
	double sigma;
	double epsilon;
	int step_mode_flag;
	double t_0;
	double h;
	double eps_abs;
	double eps_rel;
	double x_0;
	double v_0;
	size_t i_num;
	double t_end;
	double delta;
	double k;
	double A;
	size_t r_num;
	dma_dbl_array *r;
	dma_dbl_array *u;
	dma_dbl_array *dudr;
	size_t parame_size;
	double *parame;
} param;

double V(const double V_0, const double r, const double r_max, param * p);
double dVdr(const double V_0, const double r, const double r_max,
	    param * p);

double V(V_0, r, r_max, p)
const double V_0;
const double r;
const double r_max;
param *p;
{
	double tmp = gsl_pow_6(p->sigma / r);
	return p->epsilon * (tmp * tmp - 2 * tmp);
	return p->m * p->omega * p->omega * r * r / 2;
	if (0 <= r && r < r_max) {
		return V_0;
	} else {
		return 0;
	}
}

double dVdr(V_0, r, r_max, p)
const double V_0;
const double r;
const double r_max;
param *p;
{
	double tmp = -6 * gsl_pow_5(p->sigma / r) * p->sigma / r / r;
	return p->epsilon * (2 * gsl_pow_6(p->sigma / r) * tmp - 2 * tmp);
	return p->m * p->omega * p->omega * r;
	return 0;
	printf("%e", V_0);
	if (0 <= r && r < r_max) {
		return 0;
	} else {
		return 0;
	}
}

void param_new(param * p);
void param_free(param * p);
void param_print(param * p);

void param_new(p)
param *p;
{
	/*
	   double C = -sqrt((p->epsilon * pow(p->sigma, 12.0)) / 25);
	 */
	unsigned int i = 0;
	double C = 0.0;
	const double hbar = GSL_CONST_MKSA_PLANCKS_CONSTANT_HBAR;
	p->m = hbar * hbar / 2;
	p->l = 1;
	p->E = 5.0;
	p->V_0 = -25.0;
	p->omega = 2.0 / hbar;
	p->r_max = 2.0;
	p->sigma = 1.0;
	p->sigma = 3.57 * GSL_CONST_MKSA_ANGSTROM;
	p->epsilon = 1.0;
	p->epsilon =
	    5.9 * GSL_CONST_NUM_MILLI * GSL_CONST_MKSA_ELECTRON_VOLT *
	    GSL_CONST_MKSA_ELECTRON_VOLT;
	p->step_mode_flag = 0;
	p->h = 1e-6;
	p->eps_abs = 1e-16;
	p->eps_rel = 1e-16;
	p->x_0 = 0.0;
	p->v_0 = 1.0;
	p->i_num = 1000;
	p->t_end = 5E-16;
	p->t_end = 20.0;
	C = gsl_pow_6(p->sigma);
	C *= p->epsilon * C / 25;
	C = -sqrt(C);
	p->t_0 = DBL_MIN;
	p->t_0 = GSL_DBL_EPSILON;
	p->x_0 = exp(C / (gsl_pow_5(p->t_0)));
	p->v_0 = p->x_0 * (C * (-5) / gsl_pow_6(p->t_0));
	i = 0;
	p->delta = 0.138474818354818;	/*norm_rad(6.0); */
	p->k = sqrt(2 * p->m * p->E) / hbar;
	p->A = 2.73547e+31;	/*1E+16; */
	p->r_num = 100;
	p->r = dma_array_new(p->r_num);
	p->u = dma_array_new(p->r_num);
	p->dudr = dma_array_new(p->r_num);
	/*
	   p->u->size = 100;
	   p->u->data = (double *)chk_calloc(p->u_num, sizeof(double));
	   {
	   double d = 0.0;
	   do{
	   d = -30 * C  * exp(C/gsl_pow_5(p->t_0))/ gsl_pow_7(p->t_0);
	   d = (p->epsilon*p->t_0-3*sqrt(p->epsilon));
	   d *= 2*exp((-sqrt(p->epsilon)*gsl_pow_6(p->sigma))/(5*gsl_pow_5(p->t_0)));
	   d *= gsl_pow_6(p->sigma)/gsl_pow_7(p->t_0);
	   printf("# % e\t% e\t% e\t% d\n",p->t_0,d,V(p->V_0, p->t_0, p->r_max, p),i);
	   p->t_0 *= 2.0;
	   i++;
	   }while (gsl_fcmp(d, 0.0, GSL_DBL_EPSILON) == 0);
	   p->x_0 = exp(C / (gsl_pow_5(p->t_0)));
	   p->v_0 = p->x_0 * (C * (-5) / gsl_pow_6(p->t_0));
	   printf("# end\n");
	   }
	   * */
	return;
}

void param_free(p)
param *p;
{
	dma_array_free(p->r);
	dma_array_free(p->u);
	dma_array_free(p->dudr);
	free(p);
	p = NULL;
	return;
}

void param_print(p)
param *p;
{
	DEBUG_PRINT2("% e", p->m);
	DEBUG_PRINT2("% d", p->l);
	DEBUG_PRINT2("% e", p->E);
	DEBUG_PRINT2("% e", p->V_0);
	DEBUG_PRINT2("% e", p->omega);
	DEBUG_PRINT2("% e", p->r_max);
	DEBUG_PRINT2("% e", p->sigma);
	DEBUG_PRINT2("% e", p->epsilon);
	DEBUG_PRINT2("% d", p->step_mode_flag);
	DEBUG_PRINT2("% e", p->t_0);
	DEBUG_PRINT2("% e", p->h);
	DEBUG_PRINT2("% e", p->eps_abs);
	DEBUG_PRINT2("% e", p->eps_rel);
	DEBUG_PRINT2("% e", p->x_0);
	DEBUG_PRINT2("% e", p->v_0);
	DEBUG_PRINT2("% d", p->i_num);
	DEBUG_PRINT2("% e", p->t_end);
	DEBUG_PRINT2("% e", p->delta);
	DEBUG_PRINT2("% e", p->k);
	DEBUG_PRINT2("% e", p->A);
	DEBUG_PRINT2("% d", p->r_num);
	DEBUG_PRINT1(p->r);
	DEBUG_PRINT2("% d", p->r->size);
	DEBUG_PRINT1(p->r->data);
	DEBUG_PRINT2("% e", p->r->data[0]);
	DEBUG_PRINT2("% e", p->r->data[1]);
	DEBUG_PRINT2("% e", p->r->data[p->r->size - 1]);
	DEBUG_PRINT1(p->u);
	DEBUG_PRINT2("% d", p->u->size);
	DEBUG_PRINT1(p->u->data);
	DEBUG_PRINT2("% e", p->u->data[0]);
	DEBUG_PRINT2("% e", p->u->data[1]);
	DEBUG_PRINT2("% e", p->u->data[p->u->size - 1]);
	DEBUG_PRINT1(p->dudr);
	DEBUG_PRINT2("% d", p->dudr->size);
	DEBUG_PRINT1(p->dudr->data);
	DEBUG_PRINT2("% e", p->u->data[0]);
	DEBUG_PRINT2("% e", p->dudr->data[0]);
	DEBUG_PRINT2("% e", p->dudr->data[1]);
	DEBUG_PRINT2("% e", p->dudr->data[p->dudr->size - 1]);
	/*
	   dma_array_print(p->r);
	   dma_array_print(p->u);
	   dma_array_print(p->dudr);
	 */
	/*
	   const double hbar = GSL_CONST_MKSA_PLANCKS_CONSTANT_HBAR;
	   DEBUG_PRINT2("% e", GSL_DBL_EPSILON);
	   DEBUG_PRINT2("% e", DBL_MIN);
	   DEBUG_PRINT2("% e", (2.0 * p->m / (hbar * hbar)));
	   DEBUG_PRINT2("% e", (p->m * p->omega * p->omega));
	   DEBUG_PRINT2("% e", (hbar * p->omega));
	 */
	return;
}

double u(param * p, const double t);
double dudA(param * p, const double t);
double duddelta(param * p, const double t);

double u(p, t)
param *p;
const double t;
{
	const double delta = p->delta;
	const int l = p->l;
	const double kt = p->k * t;
	const double A = p->A;
	double result = 0.0;
	result += cos(delta) * gsl_sf_bessel_jl(l, kt);
	result -= sin(delta) * gsl_sf_bessel_yl(l, kt);
	result *= A * kt;
	return result;
}

double dudA(p, t)
param *p;
const double t;
{
	const double delta = p->delta;
	const int l = p->l;
	const double kt = p->k * t;
	double result = 0.0;
	result += cos(delta) * gsl_sf_bessel_jl(l, kt);
	result -= sin(delta) * gsl_sf_bessel_yl(l, kt);
	result *= kt;
	return result;
}

double duddelta(p, t)
param *p;
const double t;
{
	const double delta = p->delta;
	const int l = p->l;
	const double kt = p->k * t;
	const double A = p->A;
	double result = 0.0;
	result += -sin(delta) * gsl_sf_bessel_jl(l, kt);
	result -= cos(delta) * gsl_sf_bessel_yl(l, kt);
	result *= A * kt;
	return result;
}

/*
double F(const int l_, const double r, const double e, param * p);

double F(l_, r, e, p)
const int l_;
const double r;
const double e;
param *p;
{
	double l = (double) l_;
	const double m = (double) p->m;
	const double hbar = GSL_CONST_MKSA_PLANCKS_CONSTANT_HBAR;
	double result = 0.0;
	result =
	    V(p->V_0, r,
	      p->r_max) + hbar * hbar * l * (l + 1) / (2 * m * r * r) + e;
	return result;
}
*/

int func(double t, const double y[], double f[], void *p_);

int func(t, y, f, p_)
double t;
const double y[];
double f[];
void *p_;
{
	const double hbar = GSL_CONST_MKSA_PLANCKS_CONSTANT_HBAR;
	param *p = *(param **) p_;
	double l = (double) p->l;
	f[0] = y[1];
	f[1] = ((2.0 * p->m) / (hbar * hbar));
	f[1] *= (V(p->V_0, t, p->r_max, p) - p->E);
	f[1] += ((l * (l + 1.0)) / (t * t));
	f[1] *= y[0];
	return GSL_SUCCESS;
}

int jac(double t, const double y[], double *dfdy, double dfdt[], void *p_);

int jac(t, y, dfdy, dfdt, p_)
double t;
const double y[];
double *dfdy;
double dfdt[];
void *p_;
{
	param *p = *(param **) p_;
	double l = (double) p->l;
	const double hbar = GSL_CONST_MKSA_PLANCKS_CONSTANT_HBAR;
	gsl_matrix_view dfdy_mat;
	gsl_matrix *m;
	dfdy_mat = gsl_matrix_view_array(dfdy, 2, 2);
	m = &dfdy_mat.matrix;
	gsl_matrix_set(m, 0, 0, 0.0);
	gsl_matrix_set(m, 0, 1, 1.0);
	gsl_matrix_set(m, 1, 0,
		       ((2.0 * p->m) / (hbar * hbar)) *
		       (V(p->V_0, t, p->r_max, p) - p->E) +
		       ((l * (l + 1.0)) / (t * t)));
	gsl_matrix_set(m, 1, 1, 0.0);
	dfdt[0] = 0.0;
	dfdt[1] =
	    ((2.0 * p->m) / (hbar * hbar)) * dVdr(p->V_0, t, p->r_max, p);
	dfdt[1] -= ((2.0 * l * (l + 1.0)) / (t * t * t));
	dfdt[1] *= y[0];
	return GSL_SUCCESS;
}

void solve_radius_schrodinger_equation(param * p);

void solve_radius_schrodinger_equation(p)
param *p;
{
	size_t i = 0;
	int status = 0;
	double t = p->t_0;
	double t_end;
	double h = p->h;
	double y[2];
	const gsl_odeiv_step_type *T = gsl_odeiv_step_rk8pd;
	gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 2);
	gsl_odeiv_control *c =
	    gsl_odeiv_control_y_new(p->eps_abs, p->eps_rel);
	gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(2);
	gsl_odeiv_system sys;
	sys.function = func;
	sys.jacobian = jac;
	sys.dimension = 2;
	sys.params = &p;
	y[0] = p->x_0;
	y[1] = p->v_0;
	dma_array_set(p->r, i, t);
	dma_array_set(p->u, i, y[0]);
	dma_array_set(p->dudr, i, y[1]);
	p->r_num = p->r->size;
	printf("\n");
	printf("# t[i]\ty_0[i]\ty_1[i]\tV\tu\ti\n");
	printf("% .16e\t", t);
	printf("% .16e\t", y[0]);
	printf("% .16e\t", y[1]);
	printf("% .16e\t", V(p->V_0, t, p->r_max, p));
	printf("% .16e\t", u(p, t));
	printf("%d\n", i);
	i++;
	if (p->step_mode_flag == 1) {
		t_end = p->h;
		for (; i < p->i_num; i++) {
			while (gsl_fcmp(t, t_end, GSL_DBL_EPSILON) < 0) {
				status =
				    gsl_odeiv_evolve_apply(e, c, s, &sys,
							   &t, t_end, &h,
							   y);
				if (status != GSL_SUCCESS) {
					break;
				}
			}
			dma_array_set(p->r, i, t);
			dma_array_set(p->u, i, y[0]);
			dma_array_set(p->dudr, i, y[1]);
			p->r_num = p->r->size;
			printf("% .16e\t", t);
			printf("% .16e\t", y[0]);
			printf("% .16e\t", y[1]);
			printf("% .16e\t", V(p->V_0, t, p->r_max, p));
			printf("% .16e\t", u(p, t));
			printf("%d\n", i);
			t = t_end;
			t_end += p->h;
		}
	} else {
		t_end = p->t_end;
		while (gsl_fcmp(t, t_end, GSL_DBL_EPSILON) < 0) {
			status =
			    gsl_odeiv_evolve_apply(e, c, s, &sys, &t,
						   t_end, &h, y);
			if (status != GSL_SUCCESS) {
				printf("# status out\n");
				break;
			}
			dma_array_set(p->r, i, t);
			dma_array_set(p->u, i, y[0]);
			dma_array_set(p->dudr, i, y[1]);
			p->r_num = p->r->size;
			printf("% .16e\t", t);
			printf("% .16e\t", y[0]);
			printf("% .16e\t", y[1]);
			printf("% .16e\t", V(p->V_0, t, p->r_max, p));
			printf("% .16e\t", u(p, t));
			printf("%d\n", i);
			i++;
		}
	}
	gsl_odeiv_evolve_free(e);
	gsl_odeiv_control_free(c);
	gsl_odeiv_step_free(s);
	return;
}

void check(param * p);

void check(p)
param *p;
{
	double l = (double) p->l;
	double r = GSL_DBL_EPSILON;
	int i = 0;
	r = 0.9 * p->sigma;
	printf("\n");
	printf("#%e \n", GSL_CONST_MKSA_ELECTRON_VOLT);
	for (i = 0; i < 1000; i++) {
		r += 1.0e-12;
		printf("% e\t", r);
		printf("% e\t", V(p->V_0, r, p->r_max, p));
		printf("% e\t", dVdr(p->V_0, r, p->r_max, p));
		printf("% e\t", (l * (l + 1) / r / r));
		printf("% e\t", (1 * (1 + 1) / r / r));
		printf("% e\t", (2 * (2 + 1) / r / r));
		printf("% e\t", (3 * (3 + 1) / r / r));
		printf("% d\n", i);
	}
	return;
}

void test2(void *a);

void test2(a)
void *a;
{
	double *x_init = (double *) chk_calloc(2, sizeof(double));
	x_init[0] = 0;
	x_init[1] = 1;
	/*
	   gsl_vector_view y;
	   y = gsl_vector_view_array(x_init, 2);
	 */
	return;
	DEBUG_PRINT1(a);
}

void test(void *a);

void test(a)
void *a;
{
	size_t i = 0;
	double *tmp1 = (double *) chk_malloc(100);
	double *tmp2;
	for (i = 1; i < SIZE_MAX; i++) {
		/*
		   double *tmp = (double *)chk_malloc(i);
		   tmp2 = (double *)realloc(tmp1,i*sizeof(double));
		 */
		tmp2 = (double *) chk_calloc(i, sizeof(double));
		if (tmp2 == NULL) {
			printf("%u calloc error\n", i);
			getchar();
			free(tmp1);
			exit(EXIT_FAILURE);
		} else {
			tmp1 = tmp2;
		}
		if (i % 100000 == 0) {
			printf("%u % f %p - %p calloc\n", i,
			       ((double) i / (double) SIZE_MAX) * 100,
			       (void *) &tmp1[i - 1], (void *) &tmp1[0]);
		}
		free(tmp1);
	}
	return;
	DEBUG_PRINT1(a);
}

void print_state(size_t iter, gsl_multifit_fdfsolver * s);

void print_state(iter, s)
size_t iter;
gsl_multifit_fdfsolver *s;
{
	printf("# iter: %3u x = % 15.8f % 15.8f |f(x)| = %g\n",
	       iter,
	       gsl_vector_get(s->x, 0), gsl_vector_get(s->x, 1),
	       gsl_blas_dnrm2(s->f));
}

int calc_f(const gsl_vector * x, void *p_, gsl_vector * f);
int calc_df(const gsl_vector * x, void *p_, gsl_matrix * J);
int calc_fdf(const gsl_vector * x, void *p_, gsl_vector * f,
	     gsl_matrix * J);

int calc_f(x, p_, f)
const gsl_vector *x;
void *p_;
gsl_vector *f;
{
	param *p = *(param **) p_;
	const size_t n = p->r->size;
	const double *y = p->u->data;
	const double *r = p->r->data;
	size_t i = 0;
	p->A = gsl_vector_get(x, 0);
	p->delta = norm_rad(gsl_vector_get(x, 1));
	for (i = 0; i < n; i++) {
		double Yi = u(p, r[i]);
		gsl_vector_set(f, i, Yi - y[i]);
	}
	return GSL_SUCCESS;
}

int calc_df(x, p_, J)
const gsl_vector *x;
void *p_;
gsl_matrix *J;
{
	param *p = *(param **) p_;
	const size_t n = p->r->size;
	const double *r = p->r->data;
	size_t i = 0;
	p->A = gsl_vector_get(x, 0);
	p->delta = norm_rad(gsl_vector_get(x, 1));
	for (i = 0; i < n; i++) {
		gsl_matrix_set(J, i, 0, dudA(p, r[i]));
		gsl_matrix_set(J, i, 1, duddelta(p, r[i]));
	}
	return GSL_SUCCESS;
}

int calc_fdf(x, p_, f, J)
const gsl_vector *x;
void *p_;
gsl_vector *f;
gsl_matrix *J;
{
	calc_f(x, p_, f);
	calc_df(x, p_, J);
	return GSL_SUCCESS;
}

void fit(param * p);

void fit(p)
param *p;
{
	const gsl_multifit_fdfsolver_type *T;
	gsl_multifit_fdfsolver *s;
	int status;
	size_t iter = 0;
	gsl_vector_view x;
	gsl_matrix *covar = gsl_matrix_alloc(2, 2);
	gsl_multifit_function_fdf f;
	double x_init[2];
	x_init[0] = p->A;
	x_init[1] = norm_rad(p->delta);
	x = gsl_vector_view_array(x_init, 2);
	f.f = &calc_f;
	f.df = &calc_df;
	f.fdf = &calc_fdf;
	f.n = p->r->size;
	f.p = 2;
	f.params = &p;
	T = gsl_multifit_fdfsolver_lmsder;
	s = gsl_multifit_fdfsolver_alloc(T, f.n, f.p);
	gsl_multifit_fdfsolver_set(s, &f, &x.vector);
	/*
	   printf("# status = %s\n", gsl_strerror(status));
	   print_state(iter, s);
	 */
	do {
		iter++;
		status = gsl_multifit_fdfsolver_iterate(s);
		/*
		   printf("# status = %s\n", gsl_strerror(status));
		   print_state(iter, s);
		 */
		if (status)
			break;
		status = gsl_multifit_test_delta(s->dx, s->x, 1e-9, 1e-9);
	} while (status == GSL_CONTINUE);
	/*
	   } while (status == GSL_CONTINUE && iter < 500);
	 */
	gsl_multifit_covar(s->J, 0.0, covar);
	p->A = gsl_vector_get(s->x, 0);
	p->delta = norm_rad(gsl_vector_get(s->x, 1));
#define FIT(i) gsl_vector_get(s->x, i)
#define ERR(i) sqrt(gsl_matrix_get(covar,i,i))
	{
		double chi = gsl_blas_dnrm2(s->f);
		double dof = f.n - f.p;
		double c = GSL_MAX_DBL(1, chi / sqrt(dof));
		/*
		   printf("# chisq/dof = % .16e\n", pow(chi, 2.0) / dof);
		   printf("# A = % .16e +/- % .16e\n", FIT(0), c * ERR(0));
		   printf("# delta = % .16e +/- % .16e\n", FIT(1), c * ERR(1));
		   printf("# status = %s\n", gsl_strerror(status));
		 */
		printf("% .16e\t", pow(chi, 2.0) / dof);
		printf("% .16e\t", p->A);
		printf("% .16e\t", c * ERR(0));
		printf("% .16e\t", p->delta);
		printf("% .16e\t", c * ERR(1));
		printf("% d\t", p->r->size);
		printf("% d\t", iter);
		printf("%s\t", gsl_strerror(status));
		printf("\n");
	}
	gsl_multifit_fdfsolver_free(s);
	return;
}

void fit2(const double *x, const double *y, const size_t xy_size,
	  const double *parame, const size_t parame_size,
	  gsl_multifit_function_fdf f);
void fit2(x, y, xy_size, parame, parame_size, f)
const double *x;
const double *y;
const size_t xy_size;
const double *parame;
const size_t parame_size;
gsl_multifit_function_fdf f;
{
	return;
}

void fit_slice2(param * p);
void fit_slice2(p)
param *p;
{
	double parame[2];
	size_t i = 0;
	size_t size = p->r->size;
	double *r_data = p->r->data;
	double *u_data = p->u->data;
	double *dudr_data = p->dudr->data;
	double A_init = p->A;
	double delta_init = norm_rad(p->delta);
	double x_init[2];
	gsl_multifit_function_fdf f;
	f.f = &calc_f;
	f.df = &calc_df;
	f.fdf = &calc_fdf;
	f.n = p->r->size;
	f.p = 2;
	f.params = &p;
	printf("\n");
	printf
	    ("# chisq/dof\tA\tdA\tdelta\tddelta\tr_size\titer\tstatus\n");
	/*
	   for (i = 0; i < size - 2; i++) {
	 */
	for (i = 0; i < 2000; i++) {
		fit2(p->r->data,p->u->data,p->r->size,p->r->data,2,f);
		p->r->data = &p->r->data[1];
		p->u->data = &p->u->data[1];
		p->dudr->data = &p->dudr->data[1];
		p->r->size--;
		p->u->size--;
		p->dudr->size--;
		p->A = A_init;
		p->delta = delta_init;
	}
	p->r->size = size;
	p->u->size = size;
	p->dudr->size = size;
	p->r->data = r_data;
	p->u->data = u_data;
	p->dudr->data = dudr_data;
	return;
}

void fit_slice(param * p);
void fit_slice(p)
param *p;
{
	size_t i = 0;
	size_t size = p->r->size;
	double *r_data = p->r->data;
	double *u_data = p->u->data;
	double *dudr_data = p->dudr->data;
	double A_init = p->A;
	double delta_init = norm_rad(p->delta);
	printf("\n");
	printf
	    ("# chisq/dof\tA\tdA\tdelta\tddelta\tr_size\titer\tstatus\n");
	/*
	   for (i = 0; i < size - 2; i++) {
	 */
	for (i = 0; i < 2000; i++) {
		fit(p);
		p->r->data = &p->r->data[1];
		p->u->data = &p->u->data[1];
		p->dudr->data = &p->dudr->data[1];
		p->r->size--;
		p->u->size--;
		p->dudr->size--;
		p->A = A_init;
		p->delta = delta_init;
	}
	p->r->size = size;
	p->u->size = size;
	p->dudr->size = size;
	p->r->data = r_data;
	p->u->data = u_data;
	p->dudr->data = dudr_data;
	return;
}

int main(int argc, char **argv);

int main(argc, argv)
int argc;
char **argv;
{
	/*
	   printf("%u\n",(SIZE_MAX - 1)/2);
	   printf("%u\n",SIZE_MAX);
	   printf("%u\n",(SIZE_MAX - 1)/2SIZE_MAX);
	   dma_array_test(10);
	   test();
	   norm_rad_test(1);
	 */
	param *p;
	p = (param *) chk_calloc(1, sizeof(param));
	setbuf(stdout, NULL);
	param_new(p);
	param_print(p);
	solve_radius_schrodinger_equation(p);
	check(p);
	fit_slice(p);
	param_print(p);
	/*
	   fit(p);
	   param_print(p);
	 */
	{
		size_t i = 0;
		size_t size = p->r->size;
		double *r = p->r->data;
		printf("\n");
		printf("#r[i]\tu[i]\tdudr[i]\tV\tu(r[i])\ti\n");
		for (i = 0; i < size; i++) {
			printf("% e\t", p->r->data[i]);
			printf("% e\t", p->u->data[i]);
			printf("% e\t", p->dudr->data[i]);
			/*
			   printf("% e\t", p->u->data[i] - u(p,r[i]));
			 */
			printf("% e\t", V(p->V_0, r[i], p->r_max, p));
			printf("% e\t", u(p, r[i]));
			printf("%u\n", i);
		}
		printf("\n");
	}
	param_free(p);
	return 0;
	printf("%d", argc);
	printf("%s", argv[0]);
}

/*
int main2(void)
{
	const gsl_odeiv_step_type *T = gsl_odeiv_step_rk8pd;
	gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 2);
	gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
	gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(2);
	double mu = 10;
	gsl_odeiv_system sys = { func, jac, 2, &mu };
	double t = 0.0, t1 = 100.0;
	double h = 1e-6;
	double y[2] = { 1.0, 0.0 };
	while (t < t1) {
		int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &t,
						    t1, &h, y);
		if (status ! = GSL_SUCCESS)
			break;
		printf("%.5e %.5e %.5e\n", t, y[0], y[1]);
	}
	gsl_odeiv_evolve_free(e);
	gsl_odeiv_control_free(c);
	gsl_odeiv_step_free(s);
	return 0;
}

*/
