#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <gsl/gsl_sf_bessel.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include <gsl/gsl_math.h>
#include "debug_print.h"
#ifdef      HAVE_CONFIG_H
#include    "config.h"
#endif

double getrusage_sec(void);
int main(int, char **);

double getrusage_sec()
{
	struct rusage t;
	struct timeval tv;
	getrusage(RUSAGE_SELF, &t);
	tv = t.ru_utime;
	return tv.tv_sec + (double) tv.tv_usec * 1e-6;
}

void test(void);
void test()
{
	int i = 0;
	int l = 1;
	double x = 0.0;
	for(i=0;i<1000;i++){
		x += 0.1;
		printf("% e\t", x);
		printf("% e\t", gsl_sf_bessel_jl(l, x));
		printf("% e\t", gsl_sf_bessel_j1(x));
		printf("% e\t", (sin(x)/x-cos(x))/x);
		printf("% e\t", gsl_sf_bessel_yl(l, x));
		printf("% e\t", gsl_sf_bessel_y1(x));
		printf("% e\t", -(cos(x)/x+sin(x))/x);
		printf("% d\n", i);
	}
	return;
}

void test0(void*);
void test0(a)
void *a;
{
	double t1;
	double t2;
	double x0 = 0.0;
	double x = x0;
	double x_dif = 0.01;
	double y = 0.0;
	int k = 0;
	int i = 0;
	int j = 0;
	int i_num = 100;
	int j_num = 1000000;
	for (i = 0; i < i_num; i++) {
		t1 = getrusage_sec();
		for (j = 0; j < j_num; j++) {
			k = j + i * j_num;
			x = x0 + k * x_dif;
			y = gsl_sf_bessel_J0(x);
		}
		t2 = getrusage_sec();
		printf("% .16e\t", x);
		printf("% .16e\t", y);
		printf("% .16e\t", t2 - t1);
		printf("% d\n", k);
	}
	return;
	DEBUG_PRINT1(a);
}

int main(argc, argv)
int argc;
char **argv;
{
	test();
	return 0;
	test();
	return 0;
	printf("%d\t%s", argc, argv[0]);
}
